#ifndef __NETWORK
#define __NETWORK

#include "gameinitexit.h"

enum{
	kMessageTypeSynch=1,
	kMessageTypeSynchStart=2,
	kMessageTypeID=3,
	kMessageTypeCarID=4,
	kMessageTypeStart=5,
	kMessageTypeEndGame=6,
	kMessageTypeEndReplay=7,
	kMessageTypeGameInfo=8,
	kMessageTypePhysics=9,
	kMessageTypeChat=10,
	kMessageTypePing=11,
	kMessageTypePong=12,
	kMessageTypeJoinDenied=13,
	kMessageTypeVersionConfirmed=14,
	kMessageTypeVersionDenied=15,
	kMessageTypePause=16,
	kMessageTypeResume=17,
	kMessageTypePlayerLeft=18,
	kMessageTypePlayerJoined=19,
	kMessageTypeGameTerminated=20,
	kMessageTypeVersion=21,
	kMessageTypeKicked=22,
};

enum{
	kJoinDeniedInProgress,
	kJoinDeniedVersion
};

enum{
	kMessagePriorityLow,
	kMessagePriorityNormal,
	kMessagePriorityHigh
};

enum{
	kMessageNoRecipients=-1,
	kMessageSendToAll=-2,
	kMessageSendToAllButSelf=-3,
	kMessageSendToHostOnly=-4
};

typedef struct{
	UInt8 playerID;
	UInt8 color;
	char carName[kMaxFileNameLength];
	char playerName[256];
//	UInt32 checksum;
}tCarIDMessage;

typedef struct{
	UInt8 flags;
	float recvTime;
	char str[256];
} tChatMessage;

typedef struct{
	void *opaqueRef;
	void *data;
	int size;
	int from;
	int what;
} tNetworkPacket;


void NetworkInit();
void NetworkExit();
int JoinNetGame(char *address,int *id,int carID,char *errorString);
void HostNetGame(int maxPlayers,char *password);
int NetworkSynch(int numPlayers);
void ExitNetGame();
void NetworkSendPacket(int messageType,void *message,int size,int priority,int to);
void NetworkDisconnectPlayer(int netID);
void NetworkIdle();
int NetworkReceivePacket(tNetworkPacket* packet);
void NetworkDisposePacket(tNetworkPacket* packet);
void NetworkQueuePacket(tNetworkPacket *insert);
void NetworkClearPacketQueue();
void NetworkGetStatusString(char *str);
void NetworkPreSession();
float NetworkGetPlayerPing(int netID);
void NetworkLockOutNewPlayers();
void NetworkUnlockOutNewPlayers();
void NetworkChangePassword(char *pass);

extern int gInternetAvailable;
#endif